Object File Reference
`#include <osg/Referenced>`
`#include <osg/CopyOp>`
`#include <osg/ref_ptr>`
`#include <osg/Notify>`
`#include <string>`
`#include <vector>`

Go to the source code of this file.

## Classes

class | osg::Object
class | osg::DummyObject

## Namespaces

namespace | osg

## Macros

#define | OSG_OBJECT 1
#define | _ADDQUOTES(def)
#define | ADDQUOTES(def)
#define | META_Object(library, name)
#define | OSG_INIT_SINGLETON_PROXY(ProxyName, Func)

## Functions

template<typename T>
T * | osg::clone (const T *t, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
template<typename T>
T * | osg::clone (const T *t, const std::string &name, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
template<typename T>
T * | osg::cloneType (const T *t)
void | osg::resizeGLObjectBuffers (osg::Object *object, unsigned int maxSize)
template<class T>
void | osg::resizeGLObjectBuffers (const osg::ref_ptr< T > &object, unsigned int maxSize)
void | osg::releaseGLObjects (osg::Object *object, osg::State *state=0)
template<class T>
void | osg::releaseGLObjects (const osg::ref_ptr< T > &object, osg::State *state=0)

## Macro Definition Documentation

## _ADDQUOTES

#define _ADDQUOTES | ( |  | def | ) |

Value:
#def

## ADDQUOTES

#define ADDQUOTES | ( |  | def | ) |

Value:
_ADDQUOTES(def)
_ADDQUOTES
#define _ADDQUOTES(def)
Definition Object:39

## META_Object

#define META_Object | ( |  | library,
|  |  | name )

Value:
virtual osg::Object* cloneType() const { return new name (); } \
virtual osg::Object* clone(const osg::CopyOp& copyop) const { return new name (*this,copyop); } \
virtual bool isSameKindAs(const osg::Object* obj) const { return dynamic_cast<const name *>(obj)!=NULL; } \
virtual const char* libraryName() const { return #library; }\
virtual const char* className() const { return #name; }
osg::CopyOp
Definition CopyOp:41
osg::Object
Definition Object:61
NULL
#define NULL
Definition osg/Export:55

META_Object macro define the standard clone, isSameKindAs and className methods. Use when subclassing from Object to make it more convenient to define the standard pure virtual clone, isSameKindAs and className methods which are required for all Object subclasses.

## OSG_INIT_SINGLETON_PROXY

#define OSG_INIT_SINGLETON_PROXY | ( |  | ProxyName,
|  |  | Func )

Value:
static struct ProxyName{ ProxyName() { Func; } } s_##ProxyName;

Helper macro that creates a static proxy object to call singleton function on it's construction, ensuring that the singleton gets initialized at startup.

## OSG_OBJECT

#define OSG_OBJECT 1